#include<stdio.h>
#include<string.h>

void swap(char *a, char *b)
{
  char x = *a;
  *a = *b;
  *b = x;
}

void inverser_mot(char *mot, int longueur)
{
  if (longueur <= 1)
    return;

  swap (mot,mot+longueur-1);
  inverser_mot(mot+1, longueur-2);
}

void inverser_mots(char *texte)
{
  int i=0, debut=-1;

  while(1) {
    if(debut != -1 && (texte[i] == '\0' || texte[i] == ' ')) {
      inverser_mot(&texte[debut], i-debut);
      debut = -1;
    }
    if (debut == -1 && texte[i] != '\0' && texte[i] != ' ')
      debut = i;

    if(texte[i] == '\0') break;
    i++;
  }
}

int main(void)
{
  char phrase[] = "cette phrase gz#! x ";
  inverser_mots(phrase);
  puts(phrase);

  return 0;
}

