#include <stdio.h>
#include <stdlib.h>

#define N 6

typedef struct{
  int p[N];
  int lg;
}permutation;

void affiche_tab(int *t, int lg){
  int i;

  for(i=0; i<lg-1; i++)
    printf("%d, ", t[i]);
  printf("%d\n", t[lg-1]);
}


void applique_permutation(permutation perm, int *t){
  int i=0, j, k, x, y;

  do{
    j = i;
    x = t[i];
    do{
      y = t[perm.p[i]];
      t[perm.p[i]] = x;
      x = y;
      k = i;
      i = perm.p[i];
      perm.p[k] = -1;
    }while(i!=j);
    i = 0;
    while(perm.p[i]==-1)
      i++;
  }while(i<perm.lg);
}

void tri(int *t, int lg){
  int i,j;
  permutation perm;

  perm.lg = lg;
  for(i=0; i<lg; i++)
    perm.p[i] = 0;
  for(i=0; i<lg; i++)
    for(j=i+1; j<lg; j++){
      if(t[i] > t[j])
	perm.p[i]++;
      else
	perm.p[j]++;
    }
  applique_permutation(perm, t);
}

int main(int argc, char **argv){
  int tab[5] = {12,4,23,1,7}, lg = 5, i;
  permutation perm;

  if(argc < 3)
    exit(1);

  perm.lg = atoi(argv[1]);
  for(i=0; i<perm.lg; i++)
    perm.p[i] = atoi(argv[i+2]);
  affiche_tab(perm.p, perm.lg);
  affiche_tab(tab, lg);
  applique_permutation(perm, tab);
  affiche_tab(tab, lg);
  tri(tab, lg);
  affiche_tab(tab, lg);

  return 0;
}
