#include "frequence.h"

int frequence(char *str, char *mot){
  int i=0, compt=0, j;

  if(mot[0] == '\0')
    return -1;

  while(1){
    while(str[i] != '\0' && str[i] != mot[0])
      i++;
    if(str[i] == '\0')
      return compt;
    if(i==0 || ((str[i-1] < 'a' || str[i-1] > 'z') && (str[i-1] < 'A' || str[i-1] > 'Z'))){
      i++;
      j=1;
      while((str[i] != '\0') && (mot[j] != '\0') && (str[i] == mot[j])){
	i++;
	j++;
      }
      if((mot[j] == '\0') && ((str[i] < 'a' || str[i] > 'z') && (str[i] < 'A' || str[i] > 'Z')))
	compt++;
    }
    else
      i++;
  }
  return compt; 
}

void copie(char *dst, char *src){
  int i=-1;

  do{
    i++;
    dst[i] = src[i];
  }while(src[i] != '\0');
}

stat_mot mot_plus_frequent(char *str, int lg){
  int i=0, j=0, k, f;
  char ch[LONGUEURMAX];
  stat_mot st;

  st.freq = 0;
  while(str[i] != '\0'){
    while(str[i] != '\0' && ((str[i] >= 'a' && str[i] <= 'z') || (str[i] >= 'A' && str[i] <= 'Z'))){
      i++;
    }
    
    if(str[i] != '\0' && ((i-j) >= lg)){
      for(k=0; k<i-j; k++)
	ch[k] = str[j+k];
      ch[k] = '\0';
      f = frequence(str, ch);
      if(st.freq < f){
	st.freq = f;
	copie(st.mot,ch);
      }	
    }
    while(str[i] != '\0' && ((str[i] < 'a' || str[i] > 'z') && (str[i] < 'A' || str[i] > 'Z')))
      i++;
    j = i;
  }

  return st;
}

void init(stat_mot *t){
  int i;

  for(i=0; i<N; i++)
    t[i].freq = 0;
}

void decale(stat_mot *t, int i, int l){
  int j;

  for(j=l-1; j>=i; j--){
    t[j+1].freq = t[j].freq;
    copie(t[j+1].mot, t[j].mot);
  }
}

int compare(char *mot1, char *mot2){
  int i=0;

  while(mot1[i] != '\0' && mot2[i] != '\0' && mot1[i] == mot2[i])
    i++;
  if(mot1[i] != mot2[i])
    return 0;
  return 1;
}

void mots_plus_frequents(char *str, stat_mot *t){
  int lg=0, i=0, j=0, k, f;
  char ch[LONGUEURMAX];

  init(t);
  while(str[i] != '\0'){
    while(str[i] != '\0' && ((str[i] >= 'a' && str[i] <= 'z') || (str[i] >= 'A' && str[i] <= 'Z'))){
      i++;
    }
    
    if(str[i] != '\0'){
      for(k=0; k<i-j; k++)
	ch[k] = str[j+k];
      ch[k] = '\0';
      f = frequence(str, ch);
      k=0;
      while(k<N && t[k].freq >= f && !compare(t[k].mot,ch))
	k++;
      if(t[k].freq < f){
	if(lg<N)
	  lg++;
	if(t[k].freq != 0)
	  decale(t,k,lg);
	t[k].freq = f;
	copie(t[k].mot,ch);
      }
    }
  	
    while(str[i] != '\0' && ((str[i] < 'a' || str[i] > 'z') && (str[i] < 'A' || str[i] > 'Z')))
      i++;
    j = i;
  }
}
