#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#define TMAX 50

typedef struct {
  int length;
  int map[TMAX];
} permutation;


void applique_permutation(int h, int l, int* mat, permutation p)
{
    int copymat[h][l];
    memcpy(copymat, mat, h * l * sizeof(int));
    
    int d, i;
    for ( i=0; i < p.length; i++)
    {
	d = p.map[i];
	memcpy(mat + d * l, copymat[i], l * sizeof(int));
    }
}

affiche(int h, int l, int* t)
{
    int i,j;
    for (i = 0; i < h; i++)
    {
	for (j = 0; j < l; j++)
	    printf("%d ", *(t + i * l + j));
	printf("\n");
    }
    printf("\n");
}

int main(int argc, char **argv)
{
    int t[4][3] = {{1,2,3},{4,5,6}, {9,2,0},{8,7,6}};
    permutation p = { 4, {3,1,2,0}};
    
    affiche(4, 3, (int*)t);
    applique_permutation(4, 3, (int*)t, p);
    affiche(4, 3, (int*)t);
}

