#include <stdio.h>

#define est_lettre(s) (*s <= 'z' && *s >= 'a')
#define est_symbole(s) (! (est_lettre(s) || *s == '\n'))
#define est_retour(s) (*s == '\n')

int tautogramme(char *poeme)
{
  char lettre;
  int etat = 0;

  while(*poeme != '\0') {
    switch (etat) {
    case 0:
      if(est_lettre(poeme)) {
        lettre = *poeme;
        etat = 1;
      }
      break;
    case 1:
      if(est_symbole(poeme))
        etat = 2;
      else if (est_retour(poeme))
        etat = 0;
      break;
    case 2:
      if(est_lettre(poeme)) {
        if (*poeme != lettre) return 0;
        etat = 1;
      } else if (est_retour(poeme))
        etat = 0;
      break;
    }
    
    poeme++;
  }

  return 1;
}

int main(void)
{
  char *poeme = 
    "triste, transi, tout terni, tout tremblant\n"
    "sombre, songeant, sans sure soutenance.";

  printf("« %s » \n... %s un tautogramme\n", poeme, 
         tautogramme(poeme) ? "est" : "n'est pas");
  
  
  return 0;
}

