#include "frequence.h"

int main(int argc, char **argv){
  int freq, i;
  stat_mot st, mots[N];

  if(argc != 3){
    printf("Erreur: %d arguments",argc);
    exit(1);
  }

  freq = frequence(argv[1],argv[2]);
  if(freq < 2)
    printf("Il y a %d mot %s\n",freq, argv[2]);
  else
    printf("Il y a %d mots %s\n",freq, argv[2]);

  st = mot_plus_frequent(argv[1], 3);
  printf("Le mot le plus frequent est: %s qui apparait %d fois.\n", st.mot, st.freq);

  mots_plus_frequents(argv[1], mots);
  for(i=0; i<N; i++)
    printf("%s %d, ",mots[i].mot, mots[i].freq);
  printf("\n");

  return 0;
}
